package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLUnionSetList_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLUnionSetList extends JNIObject  {
	
	/* @generated */
	protected ISLUnionSetList(long ptr) {
		/*** PROTECTED REGION ID(ISLUnionSetList_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLUnionSetList build(long ptr) {
		return new ISLUnionSetList(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLUnionSetList_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_union_set_list_alloc 
	 * 
	 * @generated
	**/
	 public static ISLUnionSetList build(ISLContext ctx, int n) { 
		/*** PROTECTED REGION ID(static_isl_union_set_list_alloc) DISABLED START ***/
		ISLUnionSetList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionSetList.build(ISLNative.isl_union_set_list_alloc(getNativePtr(ctx), n));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_list_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLUnionSetList usetlist, int format) { 
		/*** PROTECTED REGION ID(static_isl_union_set_list_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_set_list_to_string(getNativePtr(usetlist), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_union_set_list_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_union_set_list_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_union_set_list_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_list_copy 
	 * 
	 * @generated
	**/
	public ISLUnionSetList copy() {
		/*** PROTECTED REGION ID(isl_union_set_list_copy) DISABLED START ***/
		ISLUnionSetList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionSetList.build(ISLNative.isl_union_set_list_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_list_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_union_set_list_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_union_set_list_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_list_n_union_set 
	 * 
	 * @generated
	**/
	public int getNbBasicSets() {
		/*** PROTECTED REGION ID(isl_union_set_list_n_union_set) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_set_list_n_union_set(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_list_get_union_set 
	 * 
	 * @generated
	**/
	public ISLUnionSet get(int index) {
		/*** PROTECTED REGION ID(isl_union_set_list_get_union_set) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_list_get_union_set(getNativePtr(this), index));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_list_set_union_set 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionSetList set(int index, ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_set_list_set_union_set) DISABLED START ***/
		ISLUnionSetList res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionSetList.build(ISLNative.isl_union_set_list_set_union_set(getNativePtr(this), index, getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_list_insert 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLUnionSetList insert(int pos, ISLUnionSet el) {
		/*** PROTECTED REGION ID(isl_union_set_list_insert) DISABLED START ***/
		ISLUnionSetList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLUnionSetList.build(ISLNative.isl_union_set_list_insert(getNativePtr(this), pos, getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_list_add 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLUnionSetList add(ISLUnionSet el) {
		/*** PROTECTED REGION ID(isl_union_set_list_add) DISABLED START ***/
		ISLUnionSetList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLUnionSetList.build(ISLNative.isl_union_set_list_add(getNativePtr(this), getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_list_drop 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSetList drop(int first, int n) {
		/*** PROTECTED REGION ID(isl_union_set_list_drop) DISABLED START ***/
		ISLUnionSetList res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSetList.build(ISLNative.isl_union_set_list_drop(getNativePtr(this), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_list_concat 
	 * 
	 * @take this list2
	 * @generated
	**/
	public ISLUnionSetList concat(ISLUnionSetList list2) {
		/*** PROTECTED REGION ID(isl_union_set_list_concat) DISABLED START ***/
		ISLUnionSetList res;
		
		synchronized(LOCK) {
			checkParameters(this, list2);
			try {
				res = ISLUnionSetList.build(ISLNative.isl_union_set_list_concat(getNativePtr(this), getNativePtr(list2)));
			} finally {
				taken(this);
				taken(list2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLUnionSetList_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
